import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * 
 * @author Sjaak Smetsers & Renske Smetsers-Weeda
 * @version 2.0 -- 08-08-2015
 */
public class MyDodo extends Dodo
{
    private int myNrOfEggsHatched;
    private int myNrOfStepsTaken;
    private int myEggScore;
    private int nrOfEggsFound;
    
    private int coordX; 
    private int coordY;
    
    private List<Egg> eggsInTheWorld = null;
    
    public MyDodo() {
        this ( EAST );
    }

    public MyDodo( int init_direction ) {
        super ( init_direction );
        myNrOfEggsHatched = 0;
        myNrOfStepsTaken = 0;

		
		setDestination ( 11, 0 ); // eerste bestemming gezet voor opdracht 7: 'Wereld aflopen'
    }

    public void act() {
        
    }   
    
    public void zigZag() {
    }
    

    public List<Egg> getListOfEggsInWorld() {
        return getWorld().getObjects(Egg.class);
    }
    
    /**
     * Public destination setter-methods and getter-methods
     */
    public void setDestination( int locationCoordX, int locationCoordY ){
		coordX = locationCoordX;
		coordY = locationCoordY;
	}

    public int getLocationCoordX(){
        return coordX;
    }

    public int getLocationCoordY(){
        return coordY;
    }

 
    /**
     *  hatch egg methods
     */    
    public void hatchEgg () {

        if ( foundEgg( ) ) {
            Egg foundEgg = getEgg( ); 
            if( ! foundEgg.isHatched( ) ){
                foundEgg.setHatched( );
            }
        } else {
            showError( "There was no egg in this cell" );
        }
    }

    /**
     * Move one cell forward in the current direction.
     */
    public void move() {        
        if ( canMove() ) {
            step();
        } else {
            showError( "I'm stuck!" );
        }
    
    }

    /**
     * Test if we can move forward. Return true if we can, false otherwise.
     */
    public boolean canMove() {
        if ( ! borderAhead()  && ! fenceAhead() ){
            return true;
        } else {
            return false;
        }
    }

    public boolean isEven( int value ){
        if ( value % 2 == 0){
            return true;
        } else {
            return false;
        }
    }

    public int endCoordinateX (){
        World world =  getWorld();
        if( ! isEven( world.getHeight() ) ){
            return world.getWidth();
        }else{
            return 0;
        }
    }

    public boolean hasReachedEndCoord(){
        int x_coordinate = getX();
        int y_coordinate = getY();

        World world =  getWorld();

        if( (y_coordinate == (world.getHeight()-1)) && x_coordinate == endCoordinateX() ){
            return true;
        } else {
            return false;
        }
    }

    public boolean locationReached(){
        if ( getLocationCoordX() == getX() && getLocationCoordY() == getY()){
            return true;
        } else {
            return false;
        }
    }
    
    private void stepTowardsDestination () {
        if( coordX < getX() ){
            setDirection(WEST); //turn facing west
        } else if( coordX > getX() ) {
            setDirection(EAST); //turn facing east
        } else if( coordY < getY() ) {
            setDirection(NORTH); //turn facing north
        } else {
            setDirection(SOUTH); //turn facing sounth
        }
        move();
    }

      
    private void trace( String text ) {
        System.out.println( text );
    }
            
}
